<template>
  <div class="search-page">
    <NavBar>
      <template slot="left">
        <BurgerNav />
        <div class="navbar__search hide-mobile">
          <input type="text" placeholder="Search" />
        </div>
      </template>
      <template slot="right">
        <div
          class="hide-mobile"
          v-if="currentUser && currentUser.favorites_aggregate.aggregate"
        >
          <nuxt-link
            class="navbar__links"
            :to="localePath('/profile/favorites')"
            v-wave
          >
            <svg-icon name="like" />
            <span>{{ currentUser.favorites_aggregate.aggregate.count }}</span>
          </nuxt-link>
        </div>
        <div class="hide-mobile">
          <div class="navbar__tabs">
            <div
              @click="setHomeTab('grid')"
              class="navbar__links"
              :class="{
                'is-active': homeTab == 'grid'
              }"
              v-wave
            >
              <span>Grid</span>
              <svg-icon name="tabs" />
            </div>
            <div
              @click="setHomeTab('map')"
              class="navbar__links"
              :class="{
                'is-active': homeTab == 'map'
              }"
              v-wave
            >
              <span>Map</span>
              <svg-icon name="marker" />
            </div>
          </div>
        </div>
        <div class="navbar__links" @click="toggleHomeFilter" v-wave>
          <span>Filter</span>
          <svg-icon name="filter" />
        </div>
        <nuxt-link
          v-if="currentUser"
          :to="localePath('/profile')"
          class="navbar__avatar"
        >
          <Avatar :user="currentUser" />
        </nuxt-link>
      </template>
    </NavBar>
    <div class="search-body" v-loading="loading">
      <div class="views-page">
        <div v-if="homeTab == 'grid'" class="views-page__tabs">
          <div>
            <UserGrid
              v-for="item in filterResult"
              :key="item.id"
              :data="item"
            />
          </div>
          <Footer class="search-footer" />
        </div>
        <div v-else class="views-page__maps">
          <MapSearch :result="filterResult" />
        </div>
      </div>
    </div>
    <PanelSearch />
    <FilterSearch />
  </div>
</template>

<script lang="ts">
import { defineComponent, useContext, computed } from '@nuxtjs/composition-api'
import { useGetSearchPhotographersQuery } from '~/sdk/hooks'

import useHomeTab from '@/hooks/home-tab'

import Footer from '@/components/app/Footer.vue'
import NavBar from '@/components/app/NavBar.vue'
import Button from '@/components/ui/Button.vue'

import PanelSearch from '@/components/search/PanelSearch.vue'
import MapSearch from '@/components/search/MapSearch.vue'
import UserGrid from '@/components/search/UserGrid.vue'
import FilterSearch from '@/components/search/FilterSearch.vue'

import BurgerNav from '@/components/ui/BurgerNav.vue'
import Avatar from '@/components/ui/Avatar.vue'

export default defineComponent({
  layout: 'home',
  name: 'HomePage',
  components: {
    Footer,
    Button,
    NavBar,
    FilterSearch,
    UserGrid,
    MapSearch,
    PanelSearch,

    BurgerNav,
    Avatar
  },

  head: {},
  setup(_, { root }) {
    const { app, error } = useContext()
    const currentUser = computed(() => root.$accessor.auth.user)
    const {
      homeTab,
      setHomeTab,
      toggleHomeFilter,
      filterResult,
      filterData,
      setFilterResult
    } = useHomeTab()

    const { loading, onResult: useSearchUser } = useGetSearchPhotographersQuery(
      computed(() => ({
        where: {
          // styles: filterData.value.styles.length
          //   ? {
          //       style: {
          //         name: {
          //           _in: filterData.value.styles.map((r: any) => r)
          //         }
          //       }
          //     }
          //   : null,
          // payment_types: filterData.value.payments.length
          //   ? {
          //       payment_type: {
          //         _in: filterData.value.payments.map((r: any) => r)
          //       }
          //     }
          //   : null
        },
        limit: 2000,
        offset: 0,
        orderBy:
          filterData.value.sortBy === 'Newest'
            ? ({ created_at: 'desc' } as any)
            : ({ in_favorites_aggregate: { count: 'desc' } } as any)
      }))
    )

    if (process.client) {
      useSearchUser(result => {
        if (result?.data?.search_photographers) {
          setFilterResult(result.data.search_photographers)
        }
      })
    }

    return {
      loading,
      filterResult,
      filterData,
      homeTab,
      currentUser,
      setHomeTab,
      toggleHomeFilter
    }
  }
})
</script>

<style lang="scss" scoped>
.search {
  &-body {
    /* padding: 95px 0 0 0;
    @media (min-width: 991.98px) {
      padding: 150px 85px 0 85px;
    } */
  }
  &-landing {
    text-align: center;
    margin-bottom: 45px;
    @media (min-width: 991.98px) {
      margin-bottom: 90px;
    }
    &__logo {
      img,
      svg {
        width: 65px;
        height: 65px;
        fill: #7683ad;
      }
      @media (max-width: 991.98px) {
        display: none;
      }
    }
    &__title {
      color: #ffffff;
      font-size: 24px;
      line-height: 30px;
      margin-bottom: 10px;
      @media (min-width: 991.98px) {
        font-size: 55px;
        line-height: 67px;
      }
    }
    &__description {
      color: #9badd6;
      font-size: 18px;
      line-height: 24px;
      margin-bottom: 20px;
      @media (min-width: 991.98px) {
        font-size: 30px;
        line-height: 22px;
        margin-bottom: 30px;
      }
    }
    &__links {
      display: flex;
      align-items: center;
      justify-content: center;
      > * {
        margin-right: 25px;
        &:last-child {
          margin-right: 0px;
        }
      }
    }
  }
  &-footer {
    @media (max-width: 991.98px) {
      display: none;
    }
  }
}

.search-page {
  ::v-deep {
    .filter-drawer {
      padding: 25px 15px 20px 15px;
      background: #272c3b;
      &__top {
        flex: 1;
        padding-bottom: 25px;
      }
      &__content {
        min-height: 100%;
        display: flex;
        flex-direction: column;
      }
    }
  }
}

.views-page {
  padding-top: 55px;
  @media (min-width: 991.98px) {
    padding-top: 85px;
  }
  &__tabs {
    padding: 0;
    @media (min-width: 991.98px) {
      padding: 25px 25px 0 25px;
    }
    @media (min-width: 1199.98px) {
      padding: 85px 85px 0 85px;
    }
  }
}
</style>
